# std::rank

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct rank; |  | (since C++11)

If `T` is an array type, provides the member constant `value` equal to the number of dimensions of the array. For any other type, `value` is 0.

### Helper variable template

template< class T > inline constexpr std::size_t rank_v = rank<T>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | the number of dimensions of `T` or zero (public static member constant)

### Member functions

operator std::size_t | converts the object to std::size_t, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `std::size_t`
`type` | std::integral_constant<std::size_t, value>

### Possible implementation

    template<class T>
    struct rank : public std::integral_constant<std::size_t, 0> {};

    template<class T>
    struct rank<T[]> : public std::integral_constant<std::size_t, rank<T>::value + 1> {};

    template<class T, std::size_t N>
    struct rank<T[N]> : public std::integral_constant<std::size_t, rank<T>::value + 1> {};

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    int main()
    {
        std::cout << std::rank<int[1][2][3]>::value << '\n';
        std::cout << std::rank<int[][2][3][4]>::value << '\n';
        std::cout << std::rank<int>::value << '\n';
    }

Output:

    3
    4
    0

### See also

is_array (C++11) | checks if a type is an array type (class template)
extent (C++11) | obtains the size of an array type along a specified dimension (class template)
remove_extent (C++11) | removes one extent from the given array type (class template)
remove_all_extents (C++11) | removes all extents from the given array type (class template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/types/rank&oldid=90981"